<template>
    <div :class="`${responsiveSchemes ? 'contenedor-bar-2' : 'contenedor-bar'} col-md-2 col-lg-2`" style="margin:0px; padding:0px;">
        <div class="toggle-container"  @click.prevent="toggleResponsiveSchemes()" ><a href="#"><i class="  ti-layout-grid2"></i></a></div>
        <div id="contenedoresID" class="">
            <div class="custom-scroll custom-scroll-dark">
                <ul>
                    <li class="menu-title">
                        <a href="#collapseOne3" role="tab" data-toggle="collapse" aria-expanded="true">
                            <i class="  ti-arrow-circle-right"></i> Lectura </a>
                    </li>
                </ul>
                <div id="collapseOne3" class="panel-collapse collapse in">
                    <ul class="list-group">

                        <draggable class="list-group" element="ul" v-model="le" :clone="clone" :options="options" @start="startDragging" @end="endDragging">

                            <transition-group type="transition" :name="'flip-list'">
                                <li v-for="item in le" key="li">
                                    <a href="#"><img :src="item.portrait" :alt="item.name"></a>
                                </li>
                            </transition-group>
                        </draggable>

                    </ul>
                </div>
                <ul>
                    <li class="menu-title">
                        <a href="#collapseOne4" role="tab" data-toggle="collapse" aria-expanded="true">
                            <i class="  ti-arrow-circle-right "></i> Multimedia</a>
                    </li>
                </ul>
                <div id="collapseOne4" class="panel-collapse collapse in">
                    <ul class="list-group">

                        <draggable class="list-group" element="ul" v-model="mu" :clone="clone" :options="options" @start="startDragging" @end="endDragging">

                            <transition-group type="transition" :name="'flip-list'">
                                <li v-for="item in mu" key="li">
                                    <a href="#"><img :src="item.portrait" :alt="item.name"></a>
                                </li>
                            </transition-group>
                        </draggable>

                    </ul>
                </div>
                <ul>
                    <li class="menu-title">
                        <a href="#collapseOne5" role="tab" data-toggle="collapse" aria-expanded="true">
                            <i class="  ti-arrow-circle-right "></i> Preguntas</a>
                    </li>
                </ul>
                <div id="collapseOne5" class="panel-collapse collapse in">
                    <ul class="list-group">

                        <draggable class="list-group" element="ul" v-model="pr" :clone="clone" :options="options" @start="startDragging" @end="endDragging">

                            <transition-group type="transition" :name="'flip-list'">
                                <li v-for="item in pr" key="li">
                                    <a href="#"><img :src="item.portrait" :alt="item.name"></a>
                                </li>
                            </transition-group>
                        </draggable>

                    </ul>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import draggable from 'vuedraggable'
import { mapGetters, mapActions } from 'vuex'
import ComponentManager from '../../utils/ComponentManager'
import ComponentTypes from '../../utils/ComponentTypes'
export default {
    name: 'BuilderSchemes',
    components: { draggable },
    data() {
        return {
            options: {
                group: {
                    name: 'items',
                    pull: 'clone',
                    put: false
                },
                animation: 10,
                ghostClass: 'ghost'
            },
            le: [],
            mu: [],
            pr: [],
        }
    },
    computed: {
        ...mapGetters([
            'isDragging',
            'responsiveSchemes',
        ]),
    },
    methods: {
        clone(e) {
            return Object.assign({}, {
                "component": e.component,
                "id": e.id,
                "name": e.name,
                "portrait": e.portrait,
                "result": e.result,
                "type": e.type,
                "options": Object.assign({}, e.options),
                "value": Object.assign({}, this.getCleanCopy(e.value))
            })
        },
        getCleanCopy(e) {
            let obj = {}
            for (let arg in e) {
                if (Array.isArray(e[arg])) {
                    obj[arg] = []
                    e[arg].forEach((el, index) => {
                        obj[arg].push(Object.assign({}, el))
                    })
                }
                else {
                    obj[arg] = e[arg]
                }
            }
            return obj
        },
        ...mapActions([
            'startDragging',
            'endDragging',
            'toggleResponsiveSchemes',
        ]),
    },
    mounted() {
        this.le = ComponentManager.filter((item) => item.type === ComponentTypes.TEXT)
        this.mu = ComponentManager.filter((item) => item.type === ComponentTypes.MEDIA)
        this.pr = ComponentManager.filter((item) => item.type === ComponentTypes.EVAL)
    }
}

</script>

<style>
.ghost {
    opacity: .5;
}

.contenedor-bar-2 {
    margin: 0px;
    padding: 0px;
    position: fixed;
    /* float: right; */
    /* right: -1%; */
    right: -1%;
    top: 57px;
    width: 60%;
    z-index: 6;
}


</style>
